// This file was generated by Dashcode from Apple Computer, Inc.
// You may edit this file to customize your Dashboard widget.

var Twitterlex = {};

function load() {
	setupParts();
	Twitterlex.version = 1.1;
	document.getElementById('version').innerHTML = "v"+Twitterlex.version;
	document.getElementById('refreshingTwitters').style.display = 'none';
	document.getElementById('updatingStatus').style.display = 'none';
	document.getElementById('charsIndicator').style.display = 'none';
	document.getElementById('tooLong').style.display = 'none';
	document.getElementById('updateAvailable').style.display = 'none';

	Twitterlex.username = widget.preferenceForKey(createKey('username')) || "";
	Twitterlex.password = widget.preferenceForKey(createKey('password')) || "";
	Twitterlex.lastJSON = widget.preferenceForKey(createKey('lastJSON')) || "";
	Twitterlex.updateFeedEveryWhenShown = widget.preferenceForKey(createKey('updateFeedEveryWhenShown')) || 60*1000; // 1 minute
	Twitterlex.updateFeedEveryWhenHidden = widget.preferenceForKey(createKey('updateFeedEveryWhenHidden')) || 60*1000*5; // 5 minutes
	Twitterlex.timerInterval = null;
	Twitterlex.hidden = false;

	// set up preferences
	var username = document.getElementById('username');
	username.value = Twitterlex.username;

	document.getElementById('title').innerHTML = "Twitter: "+Twitterlex.username;
	
	var password = document.getElementById('password');
	password.type = 'password';
	password.value = Twitterlex.password;

	if (!Twitterlex.username || !Twitterlex.password){
		setTimeout ('showBack();', 1000); // last long enough to do the ripple effect
	}
	checkForUpdate();
}

function createKey(key){
	return widget.identifier + '-' + key;
}

function username_onblur() {
	var username = document.getElementById('username');
	widget.setPreferenceForKey(username.value, createKey('username'));
	Twitterlex.username = widget.preferenceForKey(createKey('username'));
	document.getElementById('title').innerHTML = "Twitter: "+Twitterlex.username;
}
function password_onblur() {
	var password = document.getElementById('password');
	widget.setPreferenceForKey(password.value, createKey('password'));
	Twitterlex.password = widget.preferenceForKey(createKey('password'));
}

function updateTwitters() {
    if (Twitterlex.username != "" && Twitterlex.password != "") {
		clearInterval(Twitterlex.timerInterval);
		if (Twitterlex.hidden) {
			Twitterlex.timerInterval = setInterval("updateTwitters();", Twitterlex.updateFeedEveryWhenHidden);
		} else {
			Twitterlex.timerInterval = setInterval("updateTwitters();", Twitterlex.updateFeedEveryWhenShown);
		}
    } 
	if (Twitterlex.username == "" || Twitterlex.password == "") {
		Twitterlex.timerInterval = null;
	} else {
		document.getElementById('refreshTwitters').style.display = 'none';
		document.getElementById('refreshingTwitters').style.display = '';

		var url = "".concat("http://", Twitterlex.username.replace(/@/, "%40"), ":", Twitterlex.password, "@", "twitter.com/statuses/friends_timeline.json");
		//var url = "http://twitter.com/statuses/public_timeline.json";
		getDataFrom(url, receiveTwitters);
	}
}

function getDataFrom(url, functionToPassDataTo) {
	var http = new XMLHttpRequest();
	http.onload = function(e){ functionToPassDataTo(e, http); };
	http.setRequestHeader("Cache-Control", "no-cache");
	http.setRequestHeader('Content-type','application/x-www-form-urlencoded');
    http.open("post", url, true);
	http.send(null);
}

function receiveTwitters(e, http) {
	if (http.readyState == 4) {
		if(http.status == 200) {
			processJSON(http.responseText);
		} else {
			alert("Error loading page: readystate: " + http.readyState + ", status: " + http.status);
		}
	} else {
		alert ("Not in readystate 4: "+ http.readyState + ", status: " + http.status);
	}
	document.getElementById('refreshTwitters').style.display = '';
	document.getElementById('refreshingTwitters').style.display = 'none';
}

function processJSON(responseText) {
	// get old twitters before we overwrite them
	var oldTwitters = eval(Twitterlex.lastJSON); 
	
	// save new twitters for next update.
	widget.setPreferenceForKey(responseText, createKey('lastJSON'));
	Twitterlex.lastJSON = responseText;
		
	// start populating twitters
	clearTwitterList();
	var jsonTwitters = eval(responseText);
	var oldTwitter = false;
	var j = 0;
	for (var i= 0; i < jsonTwitters.length; i++) {
		// see if we have any new updates since last time.
		if (oldTwitters) {
			//alert("dumping "+i+": "+dump(jsonTwitters[i]));
			oldTwitter = false;
			for (j=0; j < oldTwitters.length; j++) {
				if (oldTwitters[j].id == jsonTwitters[i].id && !oldTwitter) {
					oldTwitter = true;
					break;
				}
			}
			if (!oldTwitter && Twitterlex.hidden) {
				// found a new twitter! Lets notify it!
				var obj = widget.system("osascript growlnotify.scpt 'Tweet from "+jsonTwitters[i].user.screen_name.replace(/\'/g,"\'")+"' '"+jsonTwitters[i].text.replace(/\'/g,"\'")+"'", null);
			}
		}
		// add twitter to the widget view
		addTwitterToList(jsonTwitters[i]);
	}
	refreshScrollArea();
}

function clearTwitterList() {
	document.getElementById('content').removeChild(document.getElementById('twitterlist'));
	e = document.createElement('ul');
	e.id = 'twitterlist';
	document.getElementById('content').appendChild(e);
}

function addTwitterToList(entry) {
	var twitterList = document.getElementById('twitterlist');
	var e = document.createElement('li');
	
	var a = document.createElement('a');
	a.setAttribute('href', 'http://twitter.com/'+entry.user.screen_name);
	a.onclick = function() {
		widget.openURL(this.href);
		return false;
	};
	a.setAttribute('title', a.href);
	
	var s = document.createElement('span');
	s.setAttribute('class', 'username');
	s.appendChild(document.createTextNode(entry.user.screen_name));
	a.appendChild(s);
	e.appendChild(a);
	
	var s = document.createElement('span');
	s.setAttribute('class', 'status');
	s.appendChild(document.createTextNode(' '+ entry.text+' '));
	s.setAttribute('title', entry.created_at);
	e.appendChild(s);
	
	var s = document.createElement('span');
	s.setAttribute('class', 'relative_created_at');
	s.appendChild(document.createTextNode(entry.relative_created_at));
	e.appendChild(s);
	
	twitterList.appendChild(e);
}

function refreshScrollArea() {
	document.getElementById('scrollArea').object.refresh();
}


function updateUserStatus() {
	var status = document.getElementById('status').value;
	if (status != "") { 
		document.getElementById('updatingStatus').style.display = '';
		
		var url = "".concat("http://", Twitterlex.username.replace(/@/, "%40"), ":", Twitterlex.password, "@", "twitter.com/statuses/update.json");

		var http = new XMLHttpRequest();
		http.onload = function(e){ twitterStatusUpdated(e, http); };
		http.setRequestHeader("Cache-Control", "no-cache");
		http.setRequestHeader('Content-type','application/x-www-form-urlencoded');
		http.open("post", url, true);
		http.setRequestHeader("Content-Length", status.length);
		http.send("status=" + status);
	}
}

function twitterStatusUpdated(e, http) {
	document.getElementById('status').value = "";
	document.getElementById('updatingStatus').style.display = 'none';
	updateTwitters();
}

function checkStatusLength() {
	var status = document.getElementById('status').value;
	var charsIndicator = document.getElementById('charsIndicator');
	var almostTooLong = document.getElementById('almostTooLong');
	var tooLong = document.getElementById('tooLong');
	var charsLeft = document.getElementById('charsLeft');
	// technically it's 158 - length of user name - length of status, 
	var numcharsleft = 158 - Twitterlex.username.length - status.length;
	if (numcharsleft > 30) {
		charsIndicator.style.display = 'none';
	} else if (numcharsleft <= 30 && numcharsleft >= 0 ) {
		charsIndicator.style.display = '';
		almostTooLong.style.display = '';
		tooLong.style.display = 'none';
		charsLeft.innerHTML = numcharsleft + " chars left";	
	} else if (numcharsleft < 0) {
		charsIndicator.style.display = '';
		almostTooLong.style.display = 'none';
		tooLong.style.display = '';
		charsLeft.innerHTML = 0 - numcharsleft + " chars over";	
	}
}

function handleTwitterEnterKey() {
	updateUserStatus();
	return false;
}

function handleBackEnterKey() {
    var keyCode = event.keyCode ? event.keyCode : event.which ? event.which : event.charCode;
    if (keyCode == 13) {
		username_onblur();
		password_onblur();
        showFront();
    }
}

function showTwitterlexSite() {
	widget.openURL('http://inner.geek.nz/projects/twitterlex/');
}

function checkForUpdate() {
	getDataFrom('http://inner.geek.nz/twitterlex-version.json.php', compareUpdateData);
}

function compareUpdateData(e, http) {
	if (http.readyState == 4) {
		if(http.status == 200) {
			var newinfo = eval(http.responseText);
			if (newinfo[0].currentVersion > Twitterlex.version) {
				document.getElementById('updateMessage').innerHTML = newinfo[0].message;
				document.getElementById('updateAvailable').style.display = '';
			}
		} else {
			alert("Error loading update info: readystate: " + http.readyState + ", status: " + http.status);
		}
	} else {
		alert ("Not in readystate 4: "+ http.readyState + ", status: " + http.status);
	}
}

// below are standard functions

function remove() {
	// your widget has just been removed from the layer
	// remove any preferences as needed
	widget.setPreferenceForKey(null, createInstancePreferenceKey("username"));
	widget.setPreferenceForKey(null, createInstancePreferenceKey("password"));
}

function hide() {
	document.getElementById('refreshTwitters').style.display = '';
	document.getElementById('refreshingTwitters').style.display = 'none';
	// your widget has just been hidden stop any timers to
	// prevent cpu usage
    if (Twitterlex.timerInterval != null) {
        clearInterval(Twitterlex.timerInterval);
		Twitterlex.hidden = true;
		Twitterlex.timerInterval = setInterval("updateTwitters();", Twitterlex.updateFeedEveryWhenHidden);
		// Twitterlex.timerInterval = null;
    }	
}

function show() {
	// your widget has just been shown.  restart any timers
	// and adjust your interface as needed
	Twitterlex.hidden = false;
	updateTwitters();
}

function showBack(event) {
	// your widget needs to show the back

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout('widget.performTransition();document.getElementById("username").focus();', 0);
}

function showFront(event) {
	// your widget needs to show the front

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");

	front.style.display="block";
	back.style.display="none";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
		
	show();
}

if (window.widget) {
	widget.onremove = remove;
	widget.onhide = hide;
	widget.onshow = show;
}

// horrible debug and library functions


function dump(arr,level) {
var dumped_text = "";
if(!level) level = 0;

//The padding given at the beginning of the line.
var level_padding = "";
for(var j=0;j<level+1;j++) level_padding += "    ";

if(typeof(arr) == 'object') { //Array/Hashes/Objects
 for(var item in arr) {
  var value = arr[item];
 
  if(typeof(value) == 'object') { //If it is an array,
   dumped_text += level_padding + "'" + item + "' ...\n";
   dumped_text += dump(value,level+1);
  } else {
   dumped_text += level_padding + "'" + item + "' => \"" + value + "\"\n";
  }
 }
} else { //Stings/Chars/Numbers etc.
 dumped_text = "===>"+arr+"<===("+typeof(arr)+")";
}
return dumped_text;
} 